ShieldOn = LibStub("AceAddon-3.0"):NewAddon("ShieldOn", "AceConsole-3.0", "AceEvent-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("ShieldOn")

local options = {
	name = "ShieldOn",
	handler = ShieldOn,
	type = "group",
	args = {
		instructions = {
			order = 1,
			type = "description",
			name = L["To input items: Click on a box and Shift-Click an item or Drag and drop items into boxes"],
			cmdHidden = true,
		},
		update = {
			type = "execute",
			name = L["Update Equipment Sets"],
			desc = L["Forces an update of the equipment sets"],
			func = function(info) ShieldOn:Update(info) end,
		},
		enablePvESets = {
            type = "toggle",
            name = L["PvE Sets"],
            desc = L["Toggles the updating of sets for PvE."],
            get = function(info) return ShieldOn.db.profile.PvEEnabled end,
            set = function(info, v) ShieldOn.db.profile.PvEEnabled = v end,
        },
        enablePvPSets = {
            type = "toggle",
            name = L["PvP Sets"],
            desc = L["Toggles the updating of sets for PvP."],
            get = function(info) return ShieldOn.db.profile.PvPEnabled end,
            set = function(info, v) ShieldOn.db.profile.PvPEnabled = v end,
        },
		armsPvEGroup = {
			type = "group",
			name = L["Arms PvE"],
			args = {
				armsPvE2H = {
					type = "input",
					name = L["2-Handed Weapon for Arms PvE"],
					desc = L["Stores the name of your 2-Handed weapon for Arms when doing PvE"],
					usage = L["<Name of Weapon>"],
					get = function(info) return ShieldOn.db.profile.ArmsPvE2H end,
					set = function(info,v) ShieldOn.db.profile.ArmsPvE2H = v end, 
					width = "double",
					order = 1,
				},
				armsPvE1H = {
					type = "input",
					name = L["1-Handed Weapon for Arms PvE"],
					desc = L["Stores the name of your 1-Handed weapon for Arms when doing PvE"],
					usage = L["<Name of Weapon>"],
					get = function(info) return ShieldOn.db.profile.ArmsPvE1H end,
					set = function(info,v) ShieldOn.db.profile.ArmsPvE1H = v end, 
					width = "double",
					order = 2,
				},
				armsPvEShield = {
					type = "input",
					name = L["Shield for Arms PvE"],
					desc = L["Stores the name of your Shield for Arms when doing PvE"],
					usage = L["<Name of Shield>"],
					get = function(info) return ShieldOn.db.profile.ArmsPvEShield end,
					set = function(info,v) ShieldOn.db.profile.ArmsPvEShield = v end, 
					width = "double",
					order = 3,
				},
			},
		},
		armsPvPGroup = {
			type = "group",
			name = L["Arms PvP"],
			args = {
				armsPvP2H = {
					type = "input",
					name = L["2-Handed Weapon for Arms PvP"],
					desc = L["Stores the name of your 2-Handed weapon for Arms when doing PvP"],
					usage = L["<Name of Weapon>"],
					get = function(info) return ShieldOn.db.profile.ArmsPvP2H end,
					set = function(info,v) ShieldOn.db.profile.ArmsPvP2H = v end, 
					width = "double",
					order = 1,
				},
				armsPvP1H = {
					type = "input",
					name = L["1-Handed Weapon for Arms PvP"],
					desc = L["Stores the name of your 1-Handed weapon for Arms when doing PvP"],
					usage = L["<Name of Weapon>"],
					get = function(info) return ShieldOn.db.profile.ArmsPvP1H end,
					set = function(info,v) ShieldOn.db.profile.ArmsPvP1H = v end, 
					width = "double",
					order = 2,
				},
				armsPvPShield = {
					type = "input",
					name = L["Shield for Arms PvP"],
					desc = L["Stores the name of your Shield for Arms when doing PvP"],
					usage = L["<Name of Shield>"],
					get = function(info) return ShieldOn.db.profile.ArmsPvPShield end,
					set = function(info,v) ShieldOn.db.profile.ArmsPvPShield = v end, 
					width = "double",
					order = 3,
				},
			},
		},
		furyPvEGroup = {
			type = "group",
			name = L["Fury PvE"],
			args = {
				furyPvE2HMH = {
					type = "input",
					name = L["2-Handed Mainhand Weapon for Fury PvE"],
					desc = L["Stores the name of your 2-Handed Mainhand weapon for Fury (Titan's Grip) when doing PvE"],
					usage = L["<Name of Weapon>"],
					get = function(info) return ShieldOn.db.profile.FuryPvE2HMH end,
					set = function(info,v) ShieldOn.db.profile.FuryPvE2HMH = v end, 
					width = "double",
					order = 1,
				},
				furyPvE2HOH = {
					type = "input",
					name = L["2-Handed Offhand Weapon for Fury PvE"],
					desc = L["Stores the name of your 2-Handed Offhand weapon for Fury (Titan's Grip) when doing PvE"],
					usage = L["<Name of Weapon>"],
					get = function(info) return ShieldOn.db.profile.FuryPvE2HOH end,
					set = function(info,v) ShieldOn.db.profile.FuryPvE2HOH = v end, 
					width = "double",
					order = 2,
				},
				furyPvE1HMH = {
					type = "input",
					name = L["1-Handed Mainhand Weapon for Fury PvE"],
					desc = L["Stores the name of your 1-Handed Mainhand weapon for Fury (Single-Minded) when doing PvE"],
					usage = L["<Name of Weapon>"],
					get = function(info) return ShieldOn.db.profile.FuryPvE1HMH end,
					set = function(info,v) ShieldOn.db.profile.FuryPvE1HMH = v end, 
					width = "double",
					order = 3,
				},
				furyPvE1HOH = {
					type = "input",
					name = L["1-Handed Offhand Weapon for Fury PvE"],
					desc = L["Stores the name of your 1-Handed Offhand weapon for Fury (Single-Minded) when doing PvE"],
					usage = L["<Name of Weapon>"],
					get = function(info) return ShieldOn.db.profile.FuryPvE1HOH end,
					set = function(info,v) ShieldOn.db.profile.FuryPvE1HOH = v end, 
					width = "double",
					order = 4,
				},
				furyPvEShield = {
					type = "input",
					name = L["Shield for Fury PvE"],
					desc = L["Stores the name of your Shield for Fury when doing PvE"],
					usage = L["<Name of Shield>"],
					get = function(info) return ShieldOn.db.profile.FuryPvEShield end,
					set = function(info,v) ShieldOn.db.profile.FuryPvEShield = v end, 
					width = "double",
					order = 5,
				},
			},
		},
		furyPvPGroup = {
			type = "group",
			name = L["Fury PvP"],
			args = {
				furyPvP2HMH = {
					type = "input",
					name = L["2-Handed Mainhand Weapon for Fury PvP"],
					desc = L["Stores the name of your 2-Handed Mainhand weapon for Fury (Titan's Grip) when doing PvP"],
					usage = L["<Name of Weapon>"],
					get = function(info) return ShieldOn.db.profile.FuryPvP2HMH end,
					set = function(info,v) ShieldOn.db.profile.FuryPvP2HMH = v end, 
					width = "double",
					order = 1,
				},
				furyPvP2HOH = {
					type = "input",
					name = L["2-Handed Offhand Weapon for Fury PvP"],
					desc = L["Stores the name of your 2-Handed Offhand weapon for Fury (Titan's Grip) when doing PvP"],
					usage = L["<Name of Weapon>"],
					get = function(info) return ShieldOn.db.profile.FuryPvP2HOH end,
					set = function(info,v) ShieldOn.db.profile.FuryPvP2HOH = v end, 
					width = "double",
					order = 2,
				},
				furyPvP1HMH = {
					type = "input",
					name = L["1-Handed Mainhand Weapon for Fury PvP"],
					desc = L["Stores the name of your 1-Handed Mainhand weapon for Fury (Single-Minded) when doing PvP"],
					usage = L["<Name of Weapon>"],
					get = function(info) return ShieldOn.db.profile.FuryPvP1HMH end,
					set = function(info,v) ShieldOn.db.profile.FuryPvP1HMH = v end, 
					width = "double",
					order = 3,
				},
				furyPvP1HOH = {
					type = "input",
					name = L["1-Handed Offhand Weapon for Fury PvP"],
					desc = L["Stores the name of your 1-Handed Offhand weapon for Fury (Single-Minded) when doing PvP"],
					usage = L["<Name of Weapon>"],
					get = function(info) return ShieldOn.db.profile.FuryPvP1HOH end,
					set = function(info,v) ShieldOn.db.profile.FuryPvP1HOH = v end, 
					width = "double",
					order = 4,
				},
				furyPvPShield = {
					type = "input",
					name = L["Shield for Fury PvP"],
					desc = L["Stores the name of your Shield for Fury when doing PvP"],
					usage = L["<Name of Shield>"],
					get = function(info) return ShieldOn.db.profile.FuryPvPShield end,
					set = function(info,v) ShieldOn.db.profile.FuryPvPShield = v end, 
					width = "double",
					order = 5,
				},
			},
			
		},
		protPvEGroup = {
			type = "group",
			name = L["Protection PvE"],
			args = {
				protPvE1H = {
					type = "input",
					name = L["1-Handed Weapon for Protection PvE"],
					desc = L["Stores the name of your 1-Handed weapon for Protection when doing PvE"],
					usage = L["<Name of Weapon>"],
					get = function(info) return ShieldOn.db.profile.ProtPvE1H end,
					set = function(info,v) ShieldOn.db.profile.ProtPvE1H = v end, 
					width = "double",
					order = 1,
				},
				protPvEShield = {
					type = "input",
					name = L["Shield for Protection PvE"],
					desc = L["Stores the name of your Shield for Protection when doing PvE"],
					usage = L["<Name of Shield>"],
					get = function(info) return ShieldOn.db.profile.ProtPvEShield end,
					set = function(info,v) ShieldOn.db.profile.ProtPvEShield = v end, 
					width = "double",
					order = 2,
				},
			},
		},
		protPvPGroup = {
			type = "group",
			name = L["Protection PvP"],
			args = {
				protPvP1H = {
					type = "input",
					name = L["1-Handed Weapon for Protection PvP"],
					desc = L["Stores the name of your 1-Handed weapon for Protection when doing PvP"],
					usage = L["<Name of Weapon>"],
					get = function(info) return ShieldOn.db.profile.ProtPvP1H end,
					set = function(info,v) ShieldOn.db.profile.ProtPvP1H = v end, 
					width = "double",
					order = 1,
				},
				protPvPShield = {
					type = "input",
					name = L["Shield for Protection PvP"],
					desc = L["Stores the name of your Shield for Protection when doing PvP"],
					usage = L["<Name of Shield>"],
					get = function(info) return ShieldOn.db.profile.ProtPvPShield end,
					set = function(info,v) ShieldOn.db.profile.ProtPvPShield = v end, 
					width = "double",
					order = 2,
				},
			},
		},	
	},
}

local defaults = {
    profile = {
		PvEEnabled = true,
		PvPEnabled = false,
		ArmsPvE2H = "",
		ArmsPvE1H = "",
		ArmsPvEShield = "",
		ArmsPvP2H = "",
		ArmsPvP1H = "",
		ArmsPvPShield = "",
		FuryPvE2HMH = "",
		FuryPvE2HOH = "",
		FuryPvE1HMH = "",
		FuryPvE1HOH = "",
		FuryPvEShield = "",
		FuryPvP2HMH = "",
		FuryPvP2HOH = "",
		FuryPvP1HMH = "",
		FuryPvP1HOH = "",
		FuryPvPShield = "",
		ProtPvE1H = "",
		ProtPvEShield = "",
		ProtPvP1H = "",
		ProtPvPShield = "",
    },
}


function ShieldOn:OnInitialize()
    -- Called when the addon is loaded
    self.db = LibStub("AceDB-3.0"):New("ShieldOnDB", defaults)    
    LibStub("AceConfig-3.0"):RegisterOptionsTable("ShieldOn", options)
    self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("ShieldOn", "ShieldOn")
    self:RegisterChatCommand(L["ShieldOn"], "ChatCommand")
    self:RegisterChatCommand(L["so"], "ChatCommand")
end

function ShieldOn:OnEnable()
    -- Called when the addon is enabled
    self:RegisterEvent("PLAYER_TALENT_UPDATE")
    
end


function ShieldOn:ChatCommand(input)
	--Sets up chat commands for addon.
	if not input or input:trim() == "" then
		InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
	else
		LibStub("AceConfigCmd-3.0").HandleCommand(ShieldOn, L["so"], L["ShieldOn"], input)
	end
end

function ShieldOn:CheckSpec()
	--Works out current dominant talent tree.
	highestPointsSeen = 0
	currentSpec = ""
	
	for i = 1, GetNumTalentTabs() do
		id, name, description, iconTexture, pointsSpent, background, previewPointsSpent, isUnlocked = GetTalentTabInfo(i,false,false,GetActiveTalentGroup())
		if pointsSpent > highestPointsSeen then
			highestPointsSeen = pointsSpent
			currentSpec = name
		end
	end
	
	--currentSpec won't be correct if no points have been spent.
	if highestPointsSeen ~= 0 then 
		--currentSpec will not be either Arms, Fury or Protection.
		self.db.profile.Spec = currentSpec
		
		if currentSpec == "Fury" then
			self:CheckTitansGrip()
		end
		
		tempTalentGroup = GetActiveTalentGroup()
		if self.db.profile.ActiveTalentGroup ~= tempTalentGroup then
			self.db.profile.ActiveTalentGroup = tempTalentGroup
			self:Update()
		end	
	end
end

function ShieldOn:CheckTitansGrip()
	--Check if Titan's Grip talent has been taken or not.
	nameTalent, icon, tier, column, currRank, maxRank, isExceptional, meetsPrereq = GetTalentInfo(2,20)
	if currRank~=0 then 
		self.db.profile.TitansGripActive = "True"
	else
		self.db.profile.TitansGripActive = "False"
	end
end


function ShieldOn:PLAYER_TALENT_UPDATE()
	if self.db.profile.PvEEnabled or self.db.profile.PvPEnabled then
		self:CheckSpec()
	end
end

function ShieldOn:Update()
	--CreatePvEShieldSet will run all 4 updates if both PvE and PvP are checked.
	if self.db.profile.PvEEnabled and self.db.profile.PvPEnabled then
  		self:CreatePvEShieldSet()
  	elseif self.db.profile.PvEEnabled and  (not self.db.profile.PvPEnabled) then
  		self:CreatePvEShieldSet() 
	elseif (not self.db.profile.PvEEnabled) and self.db.profile.PvPEnabled then
		self:CreatePvPShieldSet()
	end
end

function ShieldOn:CreatePvEShieldSet()
	-- Reset slot ignore flags
    EquipmentManagerClearIgnoredSlotsForSave();
	--Ignore all armour slots.
	for i=1, 15 do
		EquipmentManagerIgnoreSlotForSave(i)
	end
	--Ignore ranged.
	EquipmentManagerIgnoreSlotForSave(18)
	--Ignore tabard.
	EquipmentManagerIgnoreSlotForSave(19)
	
	if self.db.profile.Spec == "Protection" then
		if self.db.profile.ProtPvE1H ~= "" and self.db.profile.ProtPvEShield ~= "" then
			--Equip and save Shield set
			EquipItemByName(self.db.profile.ProtPvE1H,16)
			EquipItemByName(self.db.profile.ProtPvEShield,17)
			self:SaveSetPvE2ToPvP1(L["PvEShield"])
		else
			self:Print(L["Gear necessary is missing from Protection PvE settings"])
		end
	end
	
	if self.db.profile.Spec == "Fury" then
		if self.db.profile.TitansGripActive == "True" then
		--Titan's Grip set
			if self.db.profile.FuryPvE2HMH ~= "" and self.db.profile.FuryPvEShield ~= "" then
				--Equip and save Shield set
				EquipItemByName(self.db.profile.FuryPvE2HMH,16)
				EquipItemByName(self.db.profile.FuryPvEShield,17)
				self:SaveSetPvE1ToPvE2(L["PvEShield"])
			else
				self:Print(L["Gear necessary is missing from Fury PvE settings"])
			end
		else
		--Single-Minded set
			if self.db.profile.FuryPvE1HMH ~= "" and self.db.profile.FuryPvEShield ~= "" then
				--Equip and save Shield set
				EquipItemByName(self.db.profile.FuryPvE1HMH,16)
				EquipItemByName(self.db.profile.FuryPvEShield,17)
				self:SaveSetPvE1ToPvE2(L["PvEShield"])
			else
				self:Print(L["Gear necessary is missing from Fury PvE settings"])
			end
		end
	end
	
	if self.db.profile.Spec == "Arms" then
		if self.db.profile.ArmsPvE1H ~= "" and self.db.profile.ArmsPvEShield ~= "" then
			--Equip and save Shield set
			EquipItemByName(self.db.profile.ArmsPvE1H,16)
			EquipItemByName(self.db.profile.ArmsPvEShield,17)
			self:SaveSetPvE1ToPvE2(L["PvEShield"])
		else
			self:Print(L["Gear necessary is missing from Arms PvE settings"])
		end
	end
end

function ShieldOn:CreatePvENormalSet()
	--Assuming won't need a Protection Normal set.

	-- Reset slot ignore flags
    EquipmentManagerClearIgnoredSlotsForSave();
	--Ignore all armour slots.
	for i=1, 15 do
		EquipmentManagerIgnoreSlotForSave(i)
	end
	--Ignore ranged.
	EquipmentManagerIgnoreSlotForSave(18)
	--Ignore tabard.
	EquipmentManagerIgnoreSlotForSave(19)
	
	if self.db.profile.Spec == "Fury" then
		if self.db.profile.TitansGripActive == "True" then
		--Titan's Grip set
			if self.db.profile.FuryPvE2HMH ~= "" and self.db.profile.FuryPvE2HOH ~= "" then
				--Equip and save Normal set
				EquipItemByName(self.db.profile.FuryPvE2HMH,16)
				EquipItemByName(self.db.profile.FuryPvE2HOH,17)
				self:SaveSetPvE2ToPvP1(L["PvENormal"])
			else
				self:Print(L["Gear necessary is missing from Fury PvE settings"])
			end
		else
		--Single-Minded set
			if self.db.profile.FuryPvE1HMH ~= "" and self.db.profile.FuryPvE1HOH ~= "" then
				--Equip and save Normal set
				EquipItemByName(self.db.profile.FuryPvE1HMH,16)
				EquipItemByName(self.db.profile.FuryPvE1HOH,17)
				self:SaveSetPvE2ToPvP1(L["PvENormal"])
			else
				self:Print(L["Gear necessary is missing from Fury PvE settings"])
			end
		end
	end
	
	if self.db.profile.Spec == "Arms" then
		if self.db.profile.ArmsPvE2H ~= "" then
			--Equip and save Normal set
			EquipItemByName(self.db.profile.ArmsPvE2H,16)
			self:SaveSetPvE2ToPvP1(L["PvENormal"])
		else
			self:Print(L["Gear necessary is missing from Arms PvE settings"])
		end
	end
end

function ShieldOn:CreatePvPShieldSet()
	-- Reset slot ignore flags
      EquipmentManagerClearIgnoredSlotsForSave();
	--Ignore all armour slots.
	for i=1, 15 do
		EquipmentManagerIgnoreSlotForSave(i)
	end
	--Ignore ranged.
	EquipmentManagerIgnoreSlotForSave(18)
	--Ignore tabard.
	EquipmentManagerIgnoreSlotForSave(19)
	
	
	if self.db.profile.Spec == "Protection" then
		if self.db.profile.ProtPvP1H ~= "" and self.db.profile.ProtPvPShield ~= "" then
			--Equip and save Shield set
			EquipItemByName(self.db.profile.ProtPvP1H,16)
			EquipItemByName(self.db.profile.ProtPvPShield,17)	
			self:SaveSetPvP2ToEnd(L["PvPShield"],1)
		else
			self:Print(L["Gear necessary is missing from Protection PvP settings"])
		end
	end
	
	if self.db.profile.Spec == "Fury" then
		if self.db.profile.TitansGripActive == "True" then
		--Titan's Grip set
			if self.db.profile.FuryPvP2HMH ~= "" and self.db.profile.FuryPvPShield ~= "" then
				--Equip and save Shield set
				EquipItemByName(self.db.profile.FuryPvP2HMH,16)
				EquipItemByName(self.db.profile.FuryPvPShield,17)
				self:SaveSetPvP1ToPvP2(L["PvPShield"])
			else
				self:Print(L["Gear necessary is missing from Fury PvP settings"])
			end
		else
		--Single-Minded set
			if self.db.profile.FuryPvP1HMH ~= "" and self.db.profile.FuryPvPShield ~= "" then
				--Equip and save Shield set
				EquipItemByName(self.db.profile.FuryPvP1HMH,16)
				EquipItemByName(self.db.profile.FuryPvPShield,17)
				self:SaveSetPvP1ToPvP2(L["PvPShield"])
			else
				self:Print(L["Gear necessary is missing from Fury PvP settings"])
			end
		end
	end
	
	if self.db.profile.Spec == "Arms" then
		if self.db.profile.ArmsPvP1H ~= "" and self.db.profile.ArmsPvPShield ~= "" then
			--Equip and save Shield set
			EquipItemByName(self.db.profile.ArmsPvP1H,16)
			EquipItemByName(self.db.profile.ArmsPvPShield,17)
			self:SaveSetPvP1ToPvP2(L["PvPShield"])
		else
			self:Print(L["Gear necessary is missing from Arms PvP settings"])
		end
	end
end

function ShieldOn:CreatePvPNormalSet()
	--Assuming won't need a Protection Normal set.

	-- Reset slot ignore flags
    EquipmentManagerClearIgnoredSlotsForSave();
	--Ignore all armour slots.
	for i=1, 15 do
		EquipmentManagerIgnoreSlotForSave(i)
	end
	--Ignore ranged.
	EquipmentManagerIgnoreSlotForSave(18)
	--Ignore tabard.
	EquipmentManagerIgnoreSlotForSave(19)
	
	if self.db.profile.Spec == "Fury" then
		if self.db.profile.TitansGripActive == "True" then
		--Titan's Grip set
			if self.db.profile.FuryPvP2HMH ~= "" and self.db.profile.FuryPvP2HOH ~= "" then
				--Equip and save Normal set
				EquipItemByName(self.db.profile.FuryPvP2HMH,16)
				EquipItemByName(self.db.profile.FuryPvP2HOH,17)
				self:SaveSetPvP2ToEnd(L["PvPNormal"])
			else
				self:Print(L["Gear necessary is missing from Fury PvP settings"])
			end
		else
		--Single-Minded set
			if self.db.profile.FuryPvP1HMH ~= "" and self.db.profile.FuryPvP1HOH ~= "" then
				--Equip and save Normal set
				EquipItemByName(self.db.profile.FuryPvP1HMH,16)
				EquipItemByName(self.db.profile.FuryPvP1HOH,17)
				self:SaveSetPvP2ToEnd(L["PvPNormal"])
			else
				self:Print(L["Gear necessary is missing from Fury PvP settings"])
			end
		end
	end
	
	if self.db.profile.Spec == "Arms" then
		if self.db.profile.ArmsPvP2H ~= "" then
			--Equip and save Normal set
			EquipItemByName(self.db.profile.ArmsPvP2H,16)
			self:SaveSetPvP2ToEnd(L["PvPNormal"])
		else
			self:Print(L["Gear necessary is missing from Arms PvP settings"])
		end
	end
end



function ShieldOn:SaveSetPvE1ToPvE2(info)
--Can't save the set straight since gear doesn't equip in time. This confirmation provides the time delay needed.
	StaticPopupDialogs["SAVE_SET_PvE1"] = {
  		text = string.format(L["Do you want to save the set %s?"],info),
 		button1 = L["Yes"],
  		button2 = L["No"],
  		OnAccept = function() 
  			SaveEquipmentSet(info,1)
  			self:CreatePvENormalSet()
  		end,
 		timeout = 10,
 		whileDead = true,
  		hideOnEscape = true,
	}
	StaticPopup_Show ("SAVE_SET_PvE1")
end

function ShieldOn:SaveSetPvE2ToPvP1(info)
--Can't save the set straight since gear doesn't equip in time. This confirmation provides the time delay needed.
	StaticPopupDialogs["SAVE_SET_PvE2"] = {
  		text = string.format(L["Do you want to save the set %s?"],info),
 		button1 = L["Yes"],
  		button2 = L["No"],
  		OnAccept = function() 
  			SaveEquipmentSet(info,1)
  			if self.db.profile.PvPEnabled then
  				self:CreatePvPShieldSet()
  			end
  		end,
 		timeout = 10,
 		whileDead = true,
  		hideOnEscape = true,
	}
	StaticPopup_Show ("SAVE_SET_PvE2")
end

function ShieldOn:SaveSetPvP1ToPvP2(info)
--Can't save the set straight since gear doesn't equip in time. This confirmation provides the time delay needed.
	StaticPopupDialogs["SAVE_SET_PvP1"] = {
  		text = string.format(L["Do you want to save the set %s?"],info),
 		button1 = L["Yes"],
  		button2 = L["No"],
  		OnAccept = function() 
  			SaveEquipmentSet(info,1)
  			self:CreatePvPNormalSet()
  		end,
 		timeout = 10,
 		whileDead = true,
  		hideOnEscape = true,
	}
	StaticPopup_Show ("SAVE_SET_PvP1")
end

function ShieldOn:SaveSetPvP2ToEnd(info)
--Can't save the set straight since gear doesn't equip in time. This confirmation provides the time delay needed.
	StaticPopupDialogs["SAVE_SET_PvP2"] = {
  		text = string.format(L["Do you want to save the set %s?"],info),
 		button1 = L["Yes"],
  		button2 = L["No"],
  		OnAccept = function() 
  			SaveEquipmentSet(info,1)
  		end,
 		timeout = 10,
 		whileDead = true,
  		hideOnEscape = true,
	}
	StaticPopup_Show ("SAVE_SET_PvP2")
end